(* Env.sml -- environments implemented as association lists *)

type 'data env = (string * 'data) list

val empty = []

fun lookup []           x = raise Subscript
  | lookup ((y, v)::yr) x = if x=y then v else lookup yr x

fun bind1 env kv = kv :: env

fun bind env kvs = kvs @ env

fun bindZip env (ks, vs) = ListPair.zip(ks, vs) @ env

fun fromList kvs = kvs
