(* Env.sig: environments that map strings to data of type 'data *)

type 'data env

val empty    : 'data env
val lookup   : 'data env -> string -> 'data 
val bind1    : 'data env -> string * 'data -> 'data env
val bind     : 'data env -> (string * 'data) list -> 'data env
val bindZip  : 'data env -> string list * 'data list -> 'data env
val fromList : (string * 'data) list -> 'data env

